﻿using System;
using System.Collections;
using Combu;

public static class MyAddon
{
    static string URL
    {
        get
        {
            return CombuManager.instance.GetUrl("addons/myaddon/client.php");
        }
    }

    public static void CreateLeaderboard(string title, string code, Action<Leaderboard, string> onCreate)
    {
        if (!CombuManager.isInitialized)
        {
            throw new Exception("CombuManager is not initialized yet");
        }
        CombuForm form = new CombuForm();
        form.AddField("action", "create_leaderboard");
        form.AddField("Title", title);
        form.AddField("Code", code);
        CombuManager.instance.CallWebservice(URL, form, (string text, string error) =>
        {
            Leaderboard leaderboard = null;
            if (string.IsNullOrEmpty(error) && !string.IsNullOrEmpty(text))
            {
                Hashtable response = text.hashtableFromJson();
                if (response != null && response.ContainsKey("success"))
                {
                    bool success;
                    if (bool.TryParse(response["success"] + "", out success) && success)
                    {
                        leaderboard = new Leaderboard(response["message"] + "");
                    }
                    else if (!string.IsNullOrEmpty(response["message"] + ""))
                    {
                        error = response["message"].ToString();
                    }
                }
            }
            if (onCreate != null)
            {
                onCreate(leaderboard, error);
            }
        });
    }

}
