<?php

include_once '../../lib/api.php';

use Combu\Utils;
use Combu\ErrorMessage;
use Combu\LeaderBoard;

if (isset($WS_REQUEST["action"])) {
    switch ($WS_REQUEST["action"]) {
        
        case "create_leaderboard":
            wsCreateLeaderboard();
            break;
        
    }
}
$Database->CloseConnection();
exit();

/**
 * Create a leaderboard
 * @global \Combu\AppId $AppId
 * @global array[string] $WS_REQUEST
 * @global Combu\Account $LoggedAccount
 */
function wsCreateLeaderboard() {
    global $AppId, $WS_REQUEST, $LoggedAccount;
    $success = FALSE;
    $message = "";
    if (!$LoggedAccount->IsLogged()) {
        $message = ErrorMessage::Get(ERROR_USER_NOT_AUTHENTICATED);
    } else {
        $leaderboard = new LeaderBoard();
        $leaderboard->IdApp = $AppId->Id;
        // Set the score type to register only the highest per account
        $leaderboard->UniqueRecords = LeaderBoard::SCORE_UNIQUE_REPLACE_HIGHER;
        // Set the leaderboard's title and unique code sent from client
        $leaderboard->Title = $WS_REQUEST["Title"];
        $leaderboard->Code = $WS_REQUEST["Code"];
        if ($leaderboard->Code && is_numeric(substr($leaderboard->Code, 0, 1))) {
            $message = "Code cannot start with a number";
        } else if ($leaderboard->Code && $leaderboard->ExistsCode()) {
            $message = "This Code is already used for another Leaderboard";
        } else {
            // Save the leaderboard
            if ($leaderboard->Save()) {
                $success = TRUE;
                $message = $leaderboard->ToJson();
            } else {
                $message = ErrorMessage::Get(ERROR_UNEXPECTED_GENERIC);
            }
        }
    }
    Utils::EchoJson(Utils::JsonEncodeSuccessMessage($success, $message));
}
